package com.esignlive.guidance.forum;

import com.silanis.esl.sdk.DocumentPackage;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.builder.DocumentBuilder;
import com.silanis.esl.sdk.builder.FieldBuilder;
import com.silanis.esl.sdk.builder.PackageBuilder;
import com.silanis.esl.sdk.builder.SignatureBuilder;
import com.silanis.esl.sdk.builder.SignerBuilder;

public class _21_01_27_convert_coordinates {
	public static final String API_KEY = "your_api_key";
	public static final String API_URL = "https://sandbox.esignlive.com/api";

	
	public static void main(String[] args) {
		new _21_01_27_convert_coordinates().execute();
	}

	public void execute() {
		EslClient eslClient = new EslClient(API_KEY, API_URL);

		Coordinates coordinates1 = new Coordinates(80.0, 310.0, 190.0, 25.0);
		Coordinates coordinates2 = new Coordinates(85.0, 288.0, 170.0, 15.0);
		Coordinates coordinates3 = new Coordinates(75.0, 258.0, 200.0, 15.0);
		Coordinates coordinates4 = new Coordinates(295.0, 258.0, 100.0, 15.0);
		Coordinates coordinates5 = new Coordinates(400.0, 258.0, 50.0, 15.0);
		
		
		DocumentPackage pkg1 = PackageBuilder.newPackageNamed("Example Package " + System.currentTimeMillis())
				.withSigner(SignerBuilder.newSignerWithEmail("signer1@mailinator.com").withFirstName("John")
						.withLastName("Smith"))
				.withDocument(DocumentBuilder.newDocumentWithName("Document 1")
						.fromFile("path_to_file\\AUTR1012_Esign_ClaimsDoc_New.pdf")
						.withSignature(SignatureBuilder.signatureFor("signer1@mailinator.com")
								.onPage(3 - 1).atPosition(coordinates1.x, coordinates1.y).withSize(coordinates1.width,coordinates1.height)
								.withField(FieldBuilder.textField().onPage(3 - 1).atPosition(coordinates2.x, coordinates2.y).withSize(coordinates2.width,coordinates2.height))
								.withField(FieldBuilder.textField().onPage(3 - 1).atPosition(coordinates3.x, coordinates3.y).withSize(coordinates3.width,coordinates3.height))
								.withField(FieldBuilder.textField().onPage(3 - 1).atPosition(coordinates4.x, coordinates4.y).withSize(coordinates4.width,coordinates4.height))
								.withField(FieldBuilder.textField().onPage(3 - 1).atPosition(coordinates5.x, coordinates5.y).withSize(coordinates5.width,coordinates5.height))
								))
				.build();

		PackageId packageId = eslClient.createPackageOneStep(pkg1);
		System.out.println(packageId);

	}

	public class Coordinates {
		double x;
		double y;
		double width;
		double height;

		public Coordinates(double preX, double preY, double preWidth, double preHeight) {
			final double factor = 93.6 / 72.3;
			this.width = roundup2digits(factor * preWidth);
			this.height = roundup2digits(factor * preHeight);
			this.x = roundup2digits(factor * preX);
			this.y = roundup2digits(factor * (795 - preHeight - preY));
		}
		
		private double roundup2digits(double a) {
			return Math.round(a * 100.0) / 100.0;
		}
		
	}
	
	
	

}
